"""replace some game fields to player

Revision ID: 6e0e76a523c9
Revises: 18230eaed37b
Create Date: 2021-10-05 10:28:03.890618

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql
from sqlalchemy.sql.expression import text

# revision identifiers, used by Alembic.
revision = '6e0e76a523c9'
down_revision = '18230eaed37b'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        'player',
        sa.Column('remaining_move_chunks', sa.Integer(), nullable=True)
    )
    op.add_column(
        'player',
        sa.Column('is_previous_move_passed', sa.Boolean(), nullable=True)
    )

    connection = op.get_bind()
    connection.execute(
        text(
            "UPDATE player "
            "SET "
            "remaining_move_chunks= "
            "CASE "
            "WHEN player.virus::text=game.active_virus::text "
            "THEN game.remaining_move_chunks "
            "ELSE 0 "
            "END, "
            "is_previous_move_passed= "
            "CASE "
            "WHEN player.virus::text<>game.active_virus::text "
            "THEN game.is_previous_move_passed "
            "ELSE false "
            "END "
            "FROM game WHERE player.game_id=game.id "
        )
    )

    op.create_check_constraint(
        'remaining_move_chunks_count',
        'player',
        'remaining_move_chunks >= 0 AND remaining_move_chunks <= 3'
    ),
    op.alter_column('player', 'remaining_move_chunks', nullable=False)
    op.alter_column('player', 'is_previous_move_passed', nullable=False)
    op.drop_column('game', 'active_virus')
    op.drop_column('game', 'remaining_move_chunks')
    op.drop_column('game', 'is_previous_move_passed')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        'game',
        sa.Column(
            'is_previous_move_passed',
            sa.BOOLEAN(),
            autoincrement=False,
            nullable=True
        )
    )
    op.add_column(
        'game',
        sa.Column(
            'remaining_move_chunks',
            sa.INTEGER(),
            autoincrement=False,
            nullable=True
        )
    )
    op.add_column(
        'game',
        sa.Column(
            'active_virus',
            postgresql.ENUM('CROSS', 'ZERO', name='virus'),
            autoincrement=False,
            nullable=True
        )
    )

    connection = op.get_bind()
    connection.execute(
        text(
            "UPDATE game "
            "SET "
            "is_previous_move_passed=player.is_previous_move_passed "
            "FROM player WHERE player.game_id=game.id AND "
            "player.remaining_move_chunks=0 "
        )
    )
    connection.execute(
        text(
            "UPDATE game "
            "SET "
            "remaining_move_chunks=player.remaining_move_chunks, "
            "active_virus=player.virus::text::virus "
            "FROM player WHERE player.game_id=game.id AND "
            "player.remaining_move_chunks<>0 "
        )
    )

    op.drop_constraint('remaining_move_chunks_count', 'player', 'check')
    op.alter_column('game', 'active_virus', nullable=False)
    op.alter_column('game', 'remaining_move_chunks', nullable=False)
    op.drop_column('player', 'is_previous_move_passed')
    op.drop_column('player', 'remaining_move_chunks')
    # ### end Alembic commands ###
